; map.asm
;  created 10/11/02
randLevel:
 ld hl,map+23			; offset, since we need a top wall
 ld c,0
randlevelLOOP:
 inc hl
 ld a,(hl)
 cp 187
 ret z
 ld (hl),c

 call getrand
 cp 2
 jr nc,putWALLorBLANK

 and 1b
 jr z,putAxe

 ld (hl),6
 jr randlevelLOOP

putAxe:
 ld (hl),7
 jr randlevelLOOP

putWALLorBLANK:
 cp 190
 jr c,randlevelLOOP		; rewrite the last block (open/brick)

 call getrand
 ld c,0
 and 111b
 cp 5
 jr c,randlevelLOOP

 ld c,2
 jr randlevelLOOP

addLevelExit:
 call getrand
 cp 15
 jr nc,addLevelExit

 inc a
 ; multiply by 24
 ld l,a
 add a,a
 add a,l

 ld l,a
 ld h,0
 add hl,hl
 add hl,hl
 add hl,hl

 ld de,map+23
 add hl,de

 ; is the space to the left a wall?
 dec hl
 ld a,(hl)
 cp 2
 jr z,addLevelExit

 ; make a 2 space path to the exit!!!
 ld (hl),0
 dec hl
 ld (hl),0
 inc hl
 inc hl
 ld (hl),5
 ret


hideWALLS:
 ld hl,map
hidewallLOOP:
 ld a,(hl)
 cp 187
 ret z
 cp 2
 jr nz,notAwall

 call getrand
 cp 33
 jr c,notAwall

 ld (hl),1
notAwall:
 inc hl
 jr hidewallLOOP



; FIX THE BORDERS
;  place walls on the borders
fixBorders:
 ld hl,map
 ld (hl),2
 ld de,map+1
 ld bc,24
 ldir

 ld hl,maplastline
 ld (hl),2
 ld de,maplastline+1
 ld bc,23
 ldir

 ld hl,map+47		; 23+ 24*1row
 ld b,14
fixBorderSideWall:
 ld a,(hl)
 cp 5
 jr z,noSideWallButExit
 ld (hl),2
noSideWallButExit:
 inc hl
 ld (hl),2

 ld de,23
 add hl,de
 djnz fixBorderSideWall
 ret

displayMAP:
 ld hl,map
 ld c,16
resetX_mapLOOP:

 ld b,24
DISPLAYmapLOOP:
 ld a,(hl)
 or a
 jr z,blankSQUARE		; 0 produces nothing

 push hl

  push bc
   ld b,a
   ld hl,rogueSprites
   ld e,4
   ld d,0
getSPRITEloop:			; which sprite???
   add hl,de
   djnz getSPRITEloop

  pop bc				; restore values
  push bc

   ld a,16
   sub c
   ld e,a
   ld a,24
   sub b
   call sprite
  pop bc
 pop hl

blankSQUARE:
 inc hl

 djnz DISPLAYmapLOOP

 dec c
 jr nz,resetX_mapLOOP
 ret

