; utility.asm
;  created 10/11/02

waitUntilKEYup:
 ei
 halt

 ld a,0ffh 			;resets the keypad.
 out (1),a			;'Required syntax' :)
 ld a,0bfh 			;Enable group 1.
 out (1),a 			
 in a,(1) 			;'Required Syntax'

 cp 255
 jr nz,waitUntilKEYup
 ret

delay:
 push bc
 ld b,10
 ei
delayLOP:
 halt
 djnz delayLOP
 pop bc
 ret

loadPackTitle:
 ld hl,vpTitleImage
 ld de,plotsscreen+12
 ld bc,756
 ldir
 ret

loadRogueTitle:
 ld hl,rogueTitle
 ld de,plotsscreen+1
 ld bc,338
 ldir
 ret

DZM:
 ld (pencol),de
DZM2:
 jp vputsApp

; routine : Eight_l_Plus_h
; purpose : Calculates 8l + h and gives answer in A
; input   : hl
; output  : a = 8l + h
Eight_l_Plus_h:
 ld a,l                               ; a = l
 add a,a                              ; a = 2l
 add a,a                              ; a = 4l
 add a,a                              ; a = 8l
 add a,h                              ; a = 8l + h
 ret

multBy10:
 ld hl,0
 ld b,a
 or a
 ret z
 ld e,10
 ld d,0
mult10loop:
 add hl,de
 djnz mult10loop
 ret

DispText:
 ld (currow),de

putsApp:
 ld a,(hl)
 inc hl
 or a
 ret z
 B_CALL PutC
 jr putsApp

vDispText:
 ld (pencol),de
 
vputsApp:
 ld a,(hl)
 inc hl
 or a
 ret z
 push hl
 B_CALL VPutMap
 pop hl
 jr vputsApp

SdispHL:
 ld (pencol),de
 ld a,h
 or l
 jr z,disp0hl
 jr showHLnow

disp0hl:
 ld a,'0'
 B_CALL VPutMap
 ret

valueAtHL:
 ld a,(hl)
valueForA:
 push hl
 ld l,a
 ld h,0
 B_CALL setxxxxop2
 B_CALL op2toop1 
 ld a,3
 B_CALL dispop1a
 pop hl
 ret

showHL:
 ld e,(hl)
 inc hl
 ld d,(hl)
 ex de,hl
showHLnow:
 B_CALL setxxxxop2
 B_CALL op2toop1 
 ld a,5
 B_CALL dispop1a
 ret

getRandB:
 call getrand
 cp b
 jr nc,getRandB
 ret


getrand:
	 push hl
	 push bc
    push de
     ld hl,(randseed)
     ld   a,l
     ld   e,h
     add  a,h
     ld   h,a
     adc  a,e
     sub  h
     
     ld   de,4476
     add  hl,de
     adc  a,0
     
     ex   de,hl
     ld   l,d
     ld   h,a
     xor  a
     
     add  hl,hl
     adc  a,a
     add  hl,hl
     adc  a,a
     add  hl,hl
     adc  a,a
     
     ld   l,a
     ld   a,h
     add  a,e
     ld   e,a
     ld   a,l
     adc  a,d
     and  01Fh
     
     ld   l,e
     ld   h,a
     ld   (randseed),hl
	  ld a,e
     pop  de
	  pop bc
	  pop hl
     ret

;---------
;FINDPIXEL
;---------
;in:
; a=x
; e=y
;out:
; a=pixel mask
; hl=offset
findPixel:
 ld d,0
 ld hl,0
 add hl,de
 add hl,hl
 add hl,de
 add hl,hl
 add hl,hl
 push af
 srl a
 srl a
 srl a
 ld e,a
 pop af
 ld d,0
 add hl,de
 ld de,plotsscreen
 add hl,de

 ; a is preserved
 ret

invertScreen:
 ld hl,plotsscreen
 ld c,3
invertScreenOuter:
 ld b,0
invertScreenInner:
  ld a,(hl)
  xor 11111111b
  ld (hl),a
  inc hl
  djnz invertScreenInner

  dec c
  jr nz,invertScreenOuter
  ret



;*************************************
;* MODIFIED movax's routine for this
;*************************************
; displays 4x4 sprite on a 16x24 grid
;  a= x, e=y
;**********

sprite:
 push    hl             ; Save sprite address

 ld hl,0
 ld d,0
 add hl,de
 add hl,de		; y*2..
 add hl,de		; y*3...
 add hl,hl		; y*6
 add hl,hl		; y*12

 add hl,hl		; y*24
 add hl,hl		; y*48

 ld      e,a		; x/2
 srl     e
 add     hl,de

 ld      de,plotsscreen
 add     hl,de          ; Add address to graphbuf


 and 1b			; is it odd?
 jr z,ALIGN

 ;we can cheat since its always 4 off.

 pop de
 ld b,4
NOTALIGNED:
 ld a,(de)	; de->sprite location
 srl a
 srl a
 srl a
 srl a		; slide it over 4 bytes
 or (hl)
 ld (hl),a
 inc de
 push bc
 ld bc,12
 add hl,bc
 pop bc
 djnz NOTALIGNED
 ret

ALIGN:
 pop     de              ; de->sprite
 ld      b,4
ALOP1:
 ld      a,(de)
 or      (hl)            ; xor=erase/blit
 ld      (hl),a
 inc     de
 push    bc
 ld      bc,12
 add     hl,bc
 pop     bc
 djnz    ALOP1
 ret

; 8x8
sprite8xor:
 push hl		; store Sprite Pointer
 ld d,0
 ld hl,0
 add hl,de
 add hl,de
 add hl,de
 add hl,hl
 add hl,hl		; de * 12
 
 push af
 srl a
 srl a
 srl a			; x/8
 ld e,a
 add hl,de
 ex de,hl
 ld hl,plotsscreen	; 8e29h on 83
 add hl,de		; hl = location we want to paint at
 pop af
 
 and 111b
 or a
 jr z,aligned_sprite2

 pop ix
 ld e,a

 ld c,8			; loop 'c' times, for vertical sprite size
spriteNAloop2:

 ld b,e			; 'e' - the remainder of a, determines the offset
 ld d,(ix+0)
 xor a
shlop2:
 srl d			; right piece
 rr a			; left piece
 djnz shlop2

 push af
 ld a,(hl)
 xor d
 ld (hl),a		; load the two pieces of the sprite
 inc hl
 ld b,(hl)
 pop af
 xor b
 ld (hl),a

 push de		; go to next line
  ld de,11
  add hl,de
 pop de

 inc ix

 dec c
 jr nz,spriteNAloop2

 ret 
aligned_sprite2:	; hl - pointer to buffer
 pop de			; de - pointer to sprite

 ld b,8			; loops = vertical size of sprite
alop2:
 ld a,(de)
 xor (hl)
 ld (hl),a

 push de
  ld de,12
  add hl,de
 pop de
 inc de
 djnz alop2
 ret

; sprite routine for knight moves by Wouter Demuynck
WSprite:
 push hl                          
 ld hl,GRAPH_MEM                  
 ld de,0                                  
 ld e,b                                   
 srl e  ; /2
 srl e  ; /4
 srl e  ; /8                               
 add hl,de
 ld de,12
 ld b,c
 xor a
 or c
 jr z,WSprite_EndLoop
WSprite_CalcAddr:
 add hl,de
 djnz WSprite_CalcAddr
WSprite_EndLoop:
 ld b,8
WSprite_Loop:
 pop de
 ld a,(DE)
 ld (HL),a
 inc DE
 push de
 ld de,12
 add hl,de
 djnz WSprite_Loop
 pop hl               
 ret

; subhunt

PutSprite3:
 push hl
 push de
 call PutSprite
 call NextSprite
 jr Pop_N_Ret2

PutSprite2:
 call PutSprite
 call NextSprite
NextSprite:
 ld de,8
 add hl,de
 ld a,e
 add a,b
 ld b,a
;----------------------------------------------------------------------------
;[ PutSprClpXOR ] [ABCDEFIX]                      [ 139 bytes ] [ CrASH_Man ]
;----------------------------------------------------------------------------
; Draws a sprite using only XOR data, with clipping
;
; parameters: HL -> sprite, (B,C) = coordinates
; returns:    Puts sprite in GRAPH_MEM
;

PutSprite:
 PUSH HL
 push de
 PUSH BC
 push af
 CALL PutSprClpXOR
 pop af
Pop_N_Ret:
 POP BC
Pop_N_Ret2:
 pop de
 POP HL
 RET

PutSprClpXOR:
   XOR  A
__XChange_1:    LD   DE, 8     ; D = 0, E = Height

                OR   C                            ; If C < 0
                JP   M, _SCX_NoBotClp             ; No bottom clip.

                LD   A, 03Fh                       ; Is C is offscreen?
                SUB  C
                RET  C

__XChange_2:    CP   8-1       ; If C + 7 < 64
                JR   NC, _SCX_NoVertClp           ; No vertical clip.
                INC  A
                LD   E, A
                JR   _SCX_NoVertClp               ; Height = 64 - C

_SCX_NoBotClp:
__XChange_3:    CP   -(8-1)    ; Is C is offscreen?
                RET  C

                ADD  A, E                         ; Find how many lines
                LD   C, A                         ; to actually draw
                SUB  E

                NEG
                LD   E, A
                ADD  HL, DE                       ; Move HL down
                LD   E, C                         ; by -C lines
                LD   C, D

_SCX_NoVertClp: PUSH HL                           ; IX -> Sprite
                POP  IX

                LD   A, 077h                       ; OP code for
                LD   (_SCX_OPchg_1), A            ;   LD   (HL), A
                LD   (_SCX_OPchg_2), A

                XOR  A                            ; Is B > 0?
                OR   B
                JP   M, _SCX_NoRightClp

                CP   89                           ; Is B < 89?
                JR   C, _SCX_ClpDone
                CP   96
                RET  NC

                LD   HL, _SCX_OPchg_1             ; Modify LD to NOP
                JR   _SCX_ClpModify

_SCX_NoRightClp:CP   -7                           ; Is B is offscreen?
                RET  C

                LD   HL, _SCX_OPchg_2             ; Modify LD to NOP
_SCX_ClpModify: LD   (HL), D

_SCX_ClpDone:   LD   B, D
                LD   H, B
                LD   L, C
                ADD  HL, BC                       ; HL = Y * 12
                ADD  HL, BC
                ADD  HL, HL
                ADD  HL, HL

                LD   C, A                         ; HL = Y*12 + X/8
                SRA  C
                SRA  C
                SRA  C
                INC  C

                ADD  HL, BC
                LD   BC, GRAPH_MEM
                ADD  HL, BC

                LD   B, E                         ; B = number of rows

                CPL
                AND  00000111b                    ; find number of
                LD   E, A                         ; instructions to jump
                ADD  A, E
                ADD  A, E
                LD   (_SCX_OPchg_3 + 1), A        ; 3 * (7 - number)

                LD   DE, 13

_SCX_LineLoop:  LD   C, (IX)
                XOR  A
_SCX_OPchg_3:   JR   _SCX_OPchg_3                 ; modify

                RR   C
                RRA
                RR   C
                RRA
                RR   C
                RRA
                RR   C
                RRA
                RR   C
                RRA
                RR   C
                RRA
                RR   C
                RRA

                XOR  (HL)                         ; XOR with background
_SCX_OPchg_1:   LD   (HL), A                      ; Write
                DEC  HL                           ; HL -> next 8 pixels

                LD   A, C
                XOR  (HL)                         ; XOR with background
_SCX_OPchg_2:   LD   (HL), A                      ; Write
                ADD  HL, DE                       ; HL -> next row

                INC  IX                           ; Increment to next data
                DJNZ _SCX_LineLoop
                RET

DM_HL_DECI2:
 ld b,2
DM_HL_DECI:
 ld (pencol),de

 ld de,string+5
 xor a
 ld (de),a
RepUnp:
 dec de
 B_CALL divhlby10
 add a,48
 ld (de),a
 djnz RepUnp
 ex de,hl
 jr DZM2
