; VoidPack by Void Productions
;  - FallDown by Ahmed El-Helw and Florent Dhordain; ION Port: Ian Graf
;  - Knight Moves by Wouter Demunyck
;  - Rogue by Harper Maddox
;  - SubHunt by Sam Heald
; programs merged into one app by Harper Maddox

; began: 10/25/02

 include "ti83plus.inc"

; ---
; equates
;------


 ; initialize

intrptEnPort    equ 3           ; interrupt enable (in/out) 
iall                    equ 1011b 
_LCD_DRIVERON   equ 4978h 
onFlags                 equ 9           ;on key flags 
onRunning               equ 3           ; 1=calculator is running 
monFlags                equ     1       ;monitor flags 
monAbandon              equ     4       ; 1=don't start any long process in put away 
_PutAway                equ 403Ch 
_reloadAppEntryVecs equ 4C36h 
_settblgraphdraw        equ 4C00h 
_ShRAcc		equ 41D4h

diDown		.equ 254 
diLeft		.equ 253 
diRight		.equ 251 
diUp		.equ 247 
diY		.equ 239
diGraph .equ 254
di2nd		.equ 223
diMode		.equ 191
diDel		.equ 127


NUMCOLS .equ 24			; handy equate

;----
; Variables
;------------
; etc
randseed .equ appBackUpScreen

voidSafeMem .equ randseed+2

;-------------------
; FALLDOWN VARIABLES
;-------------------

falldownScore .equ voidSafeMem
ballx .equ falldownScore+2
bally .equ ballx+1
blockcnt .equ bally+1
tmpx .equ blockcnt+1

;-----------------------
; KNIGHT MOVES VARIABLES
;-----------------------

TEXT_MEM .equ voidSafeMem+450
GRAPH_MEM .equ plotsscreen

FIELD   .EQU TEXT_MEM          ; 64 bytes  Board data
YPOS    .EQU TEXT_MEM + 65     ; 1 byte    Y-position of cursor
XPOS    .EQU TEXT_MEM + 66     ; 1 byte    X-position of cursor
HORSIEY .EQU TEXT_MEM + 67     ; 1 byte    Y-position of knight
HORSIEX .EQU TEXT_MEM + 68     ; 1 byte    X-position of knight
SCORE   .EQU TEXT_MEM + 69     ; 2 bytes   Score 
;string  .EQU TEXT_MEM + 71     ; 5 bytes   (needed for DM_HL_DECI)

;----------------
; ROGUE VARIABLES
;----------------
NUMCOLS .equ 24			; handy equate

xpos equ voidSafeMem
ypos equ xpos+1
levelEnd equ ypos+1
enemies equ levelEnd+1
lives equ enemies+1
scrolls equ lives+1
axes equ scrolls+1

map equ axes+1			; 16*24+1 = 385 bytes
maplastline equ map+360
enemyTempX equ map+385
enemyTempY equ enemyTempX+1
enemy_array equ enemyTempY+1		; 768-399= approx 349 bytes is ArrayMAX
;format
; enemy X = 1st byte
; enemy Y = 2nd byte
; null terminated

;-----------------------
; SUBHUNT VARIABLES
;-----------------------
APD_BUF .equ voidSafeMem

string .equ TEXT_MEM
boatx  .equ TEXT_MEM+6
boaty  .equ TEXT_MEM+7
numlb  .equ TEXT_MEM+8
numrb  .equ TEXT_MEM+9
score  .equ TEXT_MEM+10
Bcounter .equ TEXT_MEM+12  ;counter for bullet drop speed
BWLcounter .equ TEXT_MEM+13 ;delay after firing a bullet from left
BWRcounter .equ TEXT_MEM+16 ;delay after firing a bullet from right
level .equ TEXT_MEM+14
temp .equ TEXT_MEM+15
yourHP .equ TEXT_MEM+17
temp3 .equ TEXT_MEM+18
eCounter1 .equ TEXT_MEM+19
eCounter2 .equ TEXT_MEM+20
eCounter3 .equ TEXT_MEM+21
shipsmax  .equ TEXT_MEM+22
shipsleft .equ TEXT_MEM+23
numhit    .equ TEXT_MEM+24
detonated .equ TEXT_MEM+25

ebullet1x .equ TEXT_MEM+26  ;storage for sub bullet coords
ebullet1y .equ TEXT_MEM+27  


subEnemies .equ APD_BUF          ;Enemy sprites
TEXT_MEM2 .equ APD_BUF+600


homingb1x .equ TEXT_MEM2+80
homingb1y .equ TEXT_MEM2+81


enemy1x .equ TEXT_MEM2         ;storage for enemy coords
enemy1y .equ TEXT_MEM2+1
bullet1x .equ TEXT_MEM2+20        ;storage for bullet coords
bullet1y .equ TEXT_MEM2+21
bullet6y .equ TEXT_MEM2+31

enemy1hp  .equ TEXT_MEM2+50    ;storage for hp
enemy1s  .equ TEXT_MEM2+60   ;storage for speed
enemy1d  .equ TEXT_MEM2+70


;------------------------
;--      HEADER        --
;------------------------

EXT_APP equ 1   ;This definition is required of all apps
cseg            ;This linker directive is required of all apps.

;This is the application header definition area required for all apps.
 db 080h,0Fh    ;Field: Program length
 db   00h,00h,00h,00h ;Length=0 (N/A for unsigned apps)
 db 080h,012h    ;Field: Program type
 db   01h,04h    ;Type= Shareware, TI-83Plus
 db 080h,021h    ;Field: App ID
 db   01h        ;Id = 1
 db 080h,031h    ;Field: App Build
 db   01h        ;Build = 1
 db 080h,048h    ;Field: App Name
 db "VoidPack"   ;Name = "Hello   " must be 8 characters
 db 080h,081h    ;Field: App Pages
 db 01h          ;App Pages = 1
 db 080h,090h    ;No default splash screen
 db 03h,026h ,09h,04h, 04h,06fh,01bh,80h     ;Field: Date stamp- 5/12/1999
 db 02h,0dh,040h                             ;Dummy encrypted TI date stamp signature
 db 0a1h ,06bh ,099h ,0f6h ,059h ,0bch ,067h 
 db 0f5h ,085h ,09ch ,09h ,06ch ,0fh ,0b4h ,03h ,09bh ,0c9h 
 db 03h ,032h ,02ch ,0e0h ,03h ,020h ,0e3h ,02ch ,0f4h ,02dh 
 db 073h ,0b4h ,027h ,0c4h ,0a0h ,072h ,054h ,0b9h ,0eah ,07ch 
 db 03bh ,0aah ,016h ,0f6h ,077h ,083h ,07ah ,0eeh ,01ah ,0d4h 
 db 042h ,04ch ,06bh ,08bh ,013h ,01fh ,0bbh ,093h ,08bh ,0fch 
 db 019h ,01ch ,03ch ,0ech ,04dh ,0e5h ,075h 
 db 80h,7Fh      ;Field: Program Image length
 db   0,0,0,0    ;Length=0, N/A
 db   0,0,0,0    ;Reserved
 db   0,0,0,0    ;Reserved
 db   0,0,0,0    ;Reserved
 db   0,0,0,0    ;Reserved
 
;End of header data

;------------------------
;-- START PROGRAM CODE --
;------------------------

prog_start:
 set textwrite,(iy+sGrFlags)    ; _vputs writes directly to graph
 set appTextSave,(iy+appFlags)

 include "selector.asm"


quit:
 ; exit code
    b_call  LCD_DRIVERON
    set     onRunning,(iy+onFlags)
    ei

    b_jump  JForceCmdNoChar

 ; FALLDOWN
 include "vpfallmain.asm"
 include "vpfall.asm"
 include "falldata.asm"

 ; KNIGHT MOVES
 include "vpknightmain.asm"
 include "vpknightdraw.asm"
 include "knightdata.asm"

 ; ROGUE RUNNER
 include "vproguemain.asm"
 include "roguecollision.asm"
 include "roguemap.asm"
 include "rogueenemy.asm"
 include "roguedata.asm"

 ; SUB HUNT
; include "vpsubmain.asm"
; include "subboat.asm"
; include "subdata.asm"

 ; UTILITY ROUTINES used by all progs
 include "utility.asm"
 include "vpgraphics.asm"

vpVersion: db "Void Pack v1.0",0

.end
END






