RandomBlocks:
  ld b, 12		; 12 blocks max to put
  ld hl, plotsscreen+(60*12)	; where to put blocks

rb_loop:
  push bc
  push hl
  ld b, 5
  call getRandB		; one luck on 5 to have a hole
  pop hl
  or a			; put a space ?
  jr z, rb_djnz		; yeah, so skip it
; else put the brick
  ld ix, block
  ld de, 12
  ld b, 4		; 4 lines to put
  push hl
rb_putloop:
  ld a, (ix+0)
  ld (hl), a
  inc ix
  add hl, de
  djnz rb_putloop
  pop hl
rb_djnz:
  inc hl  
  pop bc
  djnz rb_loop
; now, check there is at least one hole
;;  ld hl, $8e29+(60*12) ; not needed : works as well with second row
  ld b, 12
  xor a			; c used as number of bricks counter
rb_cloop:		; check loop
  ld c,(hl)
  rrc c
  adc a, 0
  djnz rb_cloop
  cp 12			; if less than 12 brick ( so at least one hole)
  ret c			; then exit
  ld b, a		; a was 12 if we didn't exit
  call getRandB		; put a hole somewhere
  ld hl, plotsscreen+(60*12)
  ld d, 0
  ld e, a
  add hl, de		; find where to put the hole
  ld b, 4		; 4 rows to clear
  ld e, 12		; d = 0
rb_cl_loop:		; clear loop
  ld (hl), d		; d = 0
  add hl, de		; next row
  djnz rb_cl_loop
  ret

falldownCollision:
        ld      a,(bally)               ;
        add     a,6                     ;
        ld      e,a                     ;
        ld      a,(ballx)               ;
        call    findPixel             ; check left
        ld      a,(hl)                  ;
        or      a                       ;
        jr      nz,falldownNdown                ;

        ld      a,(bally)               ;
        add     a,6                     ;
        ld      e,a                     ;
        ld      a,(ballx)               ;
        add     a,5                     ;
        call    findPixel             ; check right
        ld      a,(hl)                  ;
        or      a                       ;
       jr      nz,falldownNdown                ;

        ld      hl,(falldownScore)              ; inc score
        inc     hl                      ;
        ld      (falldownScore),hl              ;
        ld      hl,bally                ; move the ball down 
        inc     (hl)                    ;
        ld      a,(hl)                  ;
        cp      60-5                    ;
        ret     c                       ;
        dec     (hl)                    ;
        ret                             ;

falldownNdown:  ld      a,(bally)               ;
        add     a,5                     ;
        ld      e,a                     ;
        ld      a,(ballx)               ;
        call    findPixel             ; check left
        ld      a,(hl)                  ;
        or      a                       ;
        jr      nz,falldownMoveUp               ; move up
        ld      a,(bally)               ;
        add     a,5                     ;
        ld      e,a                     ;
        ld      a,(ballx)               ;
        add     a,5                     ;
        call    findPixel             ; check right
        ld      a,(hl)                  ;
        or      a                       ;
        ret     z                       ;


falldownMoveUp:

	ld      hl,bally                ;
        dec     (hl)                    ;
        ld      a,(hl)                  ;
        and     10000000b               ; y<0
        ret     z                       ;
        ;pop     hl                      ;

		  ; CANNOT FALL DOWN!!!

 ; game over

 ld hl,0
 ld (currow),hl
 ld hl,scoretxt
 call putsApp
 ld hl,(falldownScore)
 B_CALL disphl

 B_CALL getkey
 call waitUntilKEYup

 jp falldownMain

putball:
 ld a,(bally)
 ld e,a
 ld a,(ballx)
 ld hl,falldownBall
 jp sprite8xor

scroll: 
 ld      hl,plotsscreen+12             ;
        ld      de,plotsscreen                ;
        ld      bc,756                  ;
        ldir                            ;
        ld      h,d                     ;
        ld      l,e                     ;
        inc     e                       ;
        ld      (hl),b                  ;
        ld      c,11                    ;
        ldir                            ;
        ret                             ;
