DrawField:
 ld hl,FIELD                          ; hl points to the current location
 ld de,0                              ; d=0=xpos ; e=0=ypos
 ld a,1                               ; a=1(black) or 2(white)
 ld b,8                               ; loop 8 times
Drawfield_Loop1:
   push bc 
   push af                            ; save regs (A)
   ld b,8                             ; loop 8 times
Drawfield_Loop2:
     push bc
     push af
     push hl			      ; save regs (B)
     ld b,a                           ; b = 1 or 2
     ld a,(hl)
     cp 1                             ; if current location not occupied
     jr nz,knightNormal                     ; use normal treatment
     ld hl,Sprite_Used                ; else, use the sprite for used spot
     jr knightOK
knightNormal:
     ld hl,Sprite_1-8                 ; hl will be added 1 or 2 times with 8
Drawfield_Loop3:               	      ; to make hl point to the right sprite
       push de                        ; (black or white)
       ld de,8           
       add hl,de
       pop de
       djnz Drawfield_Loop3

knightOK:
     push de                          ; save DE
     ld b,d  
     ld c,e                           ; b,c contain screen coords for sprite
     call WSprite                     ; draw the sprite to GRAPH_MEM
     pop de                           ; restore DE
     ld a,d
	  add a,8
	  ld d,a        ; add d with 8 (screen coords)
     pop hl
	  pop af
	  pop bc         ; restore regs (B)
     inc hl                           ; go on to next location in mem
     xor 00000011b                    ; change a from 1 to 2 or from 2 to 1  
     djnz Drawfield_Loop2
     ld a,e 
     add a,8 
     ld e,a                           ; add e with 8 (screen coords)
     ld d,0                           ; put d back to 0 (screen coords)
     pop af
     pop bc                           ; restore regs (A)
   xor 00000011b                      ; change a from 2 -> 1 or vice versa
   djnz Drawfield_Loop1
 ld hl,(HORSIEY)                      ; draw the horse sprite
 call GetCoords                       ; get screen coords
 ld hl,Sprite_Horsie                  ; point to sprite
 call WSprite                         ; display it to GRAPH_MEM
  
 ld hl,(YPOS)                         ; draw the cursor sprite
 call GetCoords
 ld hl,Sprite_Cursor
 call WSprite

 ld hl,5*256+70                       ; hl contain coords
 ld (pencol),hl                     ; write coords to mem
 ld hl,MsgKnight                      ; load address to string
 call vputsApp                   ; display string "Knight"
 ld de,11*256+70                      ; 'DE' is used so HL gets saved 
 ld (pencol),de                     ; (hl already points to new string)
 call vputsApp                 ; display string "Moves"
 ld de,25*256+70
 ld (pencol),de
 call vputsApp                  ; display string "Score"
 ld de,40*256+70
 ld (pencol),de
 call vputsApp      

 ; disp score string
 ld hl,31*256+70
 ld (pencol),hl
 ld hl,(SCORE)
 call showHLnow

 B_CALL grbufcpy
 ret

GetCoords:
 add hl,hl                            ; h * 2 ; l * 2
 add hl,hl                            ; h * 4 ; l * 4
 add hl,hl                            ; h * 8 ; l * 8
 ld b,h 
 ld c,l                      	      ; ld bc,hl
 ret

