;
; Knight Moves v1.1                     by Wouter Demuynck (kadem@unicall.be)	83 port by BlackBelt
; http://ti82corner.home.ml.org                                  ICQ #4538550		ICQ #7525962
;
; Revisions
;  - v1.0 (February 1998) : First release, 10x10 board, 548 bytes
;  - v1.1 (March 1998) : bug fixed, commented source, 8x8 board, 499 bytes
;  - v1.1 (October 1998) : TI-83 port by BlackBelt with help from Jacob Boyce
;			     554 bytes, added high score, Slightly Optimized
;
; Last Update : 01/10/98 (October 1, 1998)


; merged into Ti83app by harper maddox

knightMain:

 ; initialize
 ld hl,TEXT_MEM
 ld (hl),0
 ld de,TEXT_MEM+1
 ld bc,80	            ;changed from 786, this is what caused the funny error
 ldir
 ld hl,TEXT_MEM
 inc (hl)                   ; set first byte of board data to 1 (used)

JustBeforeKeyLoop:
 B_CALL GrBufClr
 call DrawField             ; draw the board
knightKeyLoop:
 B_CALL getkey                ; get key scancode
 cp kMode                 ; [mode] pressed ?
 jp z,quit
; jp z,checkscore            ;   -> Exit
 cp kClear                ; [clear] pressed ?
; jp z,checkscore            ;   -> Exit
 ld hl,(YPOS)               ; H=XPOS \ L=YPOS (for later use)
 cp kEnter                ; [enter] pressed ?
 jr z,knightEnterPressed          ;   -> Check if OK to move knight
 ;cp k2nd                  ; [2nd] pressed ?              
 ;jr z,knightEnterPressed          ;   -> Check if OK to move knight
 cp kDown                 ; [DOWN] pressed ?
 jr z,knightMoveDown              ;   -> Move cursor down
 cp kLeft                       ; [LEFT] pressed ?
 jr z,knightMoveLeft              ;   -> Move cursor to the left
 cp kRight                     ; [RIGHT] pressed ?
 jr z,knightMoveRight             ;   -> Move cursor to the right
 cp kUp                     ; [UP] not pressed ?
 jr nz,knightKeyLoop              ;   -> Keep waiting for a keypress

knightMoveUp:
 dec l                      ; decrease YPOS (cursor)
 jp p,knightMove                  ; as long as l is positive it's OK 
knightMoveDown:
 inc l                      ; increase YPOS (cursor)
 ld a,8     
 cp l
 jr nz,knightMove                 ; as long as it's not 8, it's OK
 jr knightMoveUp                  ; if not OK, move it up again
knightMoveLeft:
 dec h                      ; decrease XPOS (cursor)
 jp p,knightMove                  ; positive? -> OK
knightMoveRight:
 inc h                      ; increase XPOS (cursor)
 ld a,8                     
 cp h
 jr z,knightMoveLeft              ; lower than or equal to 8 -> OK
knightMove:
 ld (YPOS),hl               ; change cursorcoords
 jr JustBeforeKeyLoop       ; return

knightEnterPressed:
 ld de,(YPOS)
 ld l,d 
 ld h,e
 call Eight_l_Plus_h
 ld b,a                       ; B contains 8*POSX+ POSY
 ld de,(HORSIEY)
 ld l,d 
 ld h,e
 call Eight_l_Plus_h          ; A contains 8*HORSIEX + HORSIEY
                             
 cp b                    
 ld l,b                       ; L is used later in the routine
 jr nc,knightDontSwap               ; if a < b then swap a and b
 ld b,a
 ld a,l                       ; swap a and b 
knightDontSwap:
 sub b                        ; substract b from a
 cp 10                        ; check if OK 
 jr z,knightNextCheck   
 cp 6 
 jr z,knightNextCheck   
 cp 17
 jr z,knightNextCheck    
 cp 15
 jp nz,knightKeyLoop
knightNextCheck:
 ld hl,(YPOS)
 call Eight_l_Plus_h
 ld b,a                       ; B contains 8*POSY + POSX
 ld h,0                     ; check if horsie has been on that spot
 ld l,b
 ld de,FIELD                ; already, and if so, go back to
 add hl,de                  ; the keyloop
 ld a,1
 cp (hl)
 jr z,knightKeyLoop
 ld hl,(HORSIEY)
 call Eight_l_Plus_h          ; A contains 8*HORSIEY + HORSIEX
 cp b                    
 ld l,b                       ; L is used later in the routine
 jr nc,DontSwap2              ; if a < b then swap a and b
 ld b,a
 ld a,l                       ; swap a and b
DontSwap2:
 sub b                        ; substract b from a
 cp 10   
 jr z,MoveThePiece
 cp 6 
 jr z,MoveThePiece
 cp 17
 jr z,MoveThePiece  
 cp 15
 jp nz,knightKeyLoop
MoveThePiece:
 ld de,FIELD
 ld h,0                       ; hl = offset of the cursor on the field
 add hl,de                    ; calculate absolute offset
 inc (hl)                     ; set that info to 1 (used)
 ld hl,(YPOS)
 ld (HORSIEY),hl              ; change coords of knight
 ld hl,(SCORE)			;needed ()'s here
 inc hl                       ; update score ;removed ()'s here
 ld (SCORE),hl			;the score was not being stored back to the variable
 jp JustBeforeKeyLoop         ; return
