;intro.asm
; began 10/11/02


 ; reset data
rogueMain:
 ld hl,voidSafeMem
 ld de,voidSafeMem+1
 ld (hl),0
 ld bc,765
 ldir

 ld a,187
 ld (map+384),a
LevelDONE:
 ld hl,enemies
 inc (hl)
 ld hl,lives
 inc (hl)

restartLevel:
 xor a
 ld (levelEnd),a

 ; Display the title graphic along with counts on your
 ;  lives, axes and scrolls

 B_CALL GrBufClr

 call loadRogueTitle

 ld hl,28*256+34
 ld (pencol),hl
 ld hl,intro_text1
 call vputsApp

 ld hl,30*256
 ld (pencol),hl
 ld a,(lives)
 B_CALL setxxop1
 ld a,2
 B_CALL dispop1a

 ld hl,game_text3
 call vputsApp

 ld hl,57*256+10
 ld (pencol),hl
 ld hl,intro_text2
 call vputsApp

 ld a,(axes)
 B_CALL setxxop1
 ld a,2
 B_CALL dispop1a

 ld hl,57*256+54
 ld (pencol),hl
 ld hl,intro_text3
 call vputsApp

 ld a,(scrolls)
 B_CALL setxxop1
 ld a,2
 B_CALL dispop1a

 B_CALL GrBufCpy

 ; show the current Level

 ld hl,0A05h
 ld (currow),hl
 ld a,(enemies)
 ld l,a
 ld h,0
 B_CALL disphl

 ld hl,0805h
 ld (currow),hl
 ld hl,game_text2
 call putsApp

 ; show the percentage complete.
 ;  this is just for show :)
 ;  the computer industry thinks this is okay to do,
 ;  so naturally i follow their example

 ld b,99
percentGRFXloop:
				; with the level % done line
 push bc			; disp Pct randomized and show graph
 ld hl,0005h			;
 ld (currow),hl			; Load coordinates for our disphl call.

 ld a,100
 sub b
 ld l,a
 ld h,0
 push hl
 B_CALL disphl			; 
 ld a,lpercent			; 
 B_CALL PutC		; Display percent mark.
 pop hl
 ld b,l
 ld c,11			; 
 ld d,1				;
 B_CALL ipoint			; Draws the "loading" line.

 ei
 halt
 halt
 halt
 halt
 pop bc
 djnz percentGRFXloop

 ; now we load the random map
 call randLevel
 call fixBorders

 B_CALL grbufclr

 call displayMAP

 B_CALL GrBufCpy

 ; delay
 ld b,15
showALLofMAP:
 call delay
 djnz showALLofMAP

 ; hide most of the walls.
 call hideWALLS

 ; add an exit
 call addLevelExit

 ; initial position for Rogue (the hero)
 ld a,2
 ld (xpos),a
 ld a,8
 ld (ypos),a

 ; eliminate wall from your current location
 ld hl,map+8*NUMCOLS+2
 ld (hl),0

 ; load the enemies

 call loadEnemies

main:
 B_CALL grbufclr
 call displayMAP

 call moveEnemies
 call showEnemies

 ; check for a collision with an enemy
 ld a,(enemies)
 ld b,a
 ld hl,enemy_array
 ld a,(xpos)
 ld d,a
 ld a,(ypos)
 ld e,a
collideWithEnemy:
 push bc
  ld a,(hl)
  cp d
  jr nz,noCollisionWithEnemy1
  inc hl
  ld a,(hl)
  cp e
  jr nz,noCollisionWithEnemy2

 pop bc

  ; we have a collision!!!

showDeathAnimation:
  call invertScreen  ; flash the screen
  B_CALL grbufcpy
  call delay
  call invertScreen
  B_CALL grbufcpy
    call delay
  call invertScreen  ; flash the screen
  B_CALL grbufcpy
  call delay
  call invertScreen
  B_CALL grbufcpy
  call delay
  call waitUntilKEYup
  ld a,(lives)
  dec a
  jp z,endGame
  ld (lives),a
  jp restartLevel

noCollisionWithEnemy1:
  inc hl
noCollisionWithEnemy2:
 pop bc
 inc hl
 djnz collideWithEnemy

 ld a,(ypos)
 ld e,a
 ld a,(xpos)
 ld hl,rogue
 call sprite

 B_CALL GrBufCpy

 ld a,(levelEnd)
 or a
 jp nz,LevelDONE

 ; wait for keypresses
 call delay

 ; DI keypresses
 ld a,0ffh 			;resets the keypad.
 out (1),a			;'Required syntax' :)
 ld a,0feh 			;Enable group 1.
 out (1),a 			
 in a,(1) 			;'Required Syntax'
 cp diLeft
 jr z,youMOVEleft
 cp diRight
 jr z,youMOVEright
 cp diUp
 jr z,youMOVEup
 cp diDown
 jr z,youMOVEdown

 ; Regular Keypresses
 ld a,0ffh 			;Reset keypad again.
 out (1),a
 ld a,0bfh			;Enable group 2.
 out (1),a 
 in a,(1)
 cp di2nd
 jp z,teleport
 cp diDel
 jp z,showDeathAnimation
 cp diMode
 jp nz,main

 jp quit

youMOVEleft:
 ld a,(xpos)
 or a
 jp z,main
 dec a
 ld (xpos),a

 call isSpaceValid
 jp c,main

 ld hl,xpos
 inc (hl)

 jp main

youMOVEright:
 ld a,(xpos)
 cp 23
 jp z,main
 inc a
 ld (xpos),a

 call isSpaceValid
 jp c,main

 ld hl,xpos
 dec (hl)

 jp main

youMOVEup:
 ld a,(ypos)
 or a
 jp z,main
 dec a
 ld (ypos),a

 call isSpaceValid
 jp c,main

 ld hl,ypos
 inc (hl)

 jp main

youMOVEdown:
 ld a,(ypos)
 cp 15
 jp z,main
 inc a
 ld (ypos),a

 call isSpaceValid
 jp c,main

 ld hl,ypos
 dec (hl)

 jp main

 ; TELEPORT code
 ;  sends you to a random location on the map

teleport:
 ld a,(scrolls)
 or a
 jp z,main
 dec a
 ld (scrolls),a

TelePORTstartover:
 call getrand
 and 11111b
 cp 24
 jr nc,TelePORTstartover
 ld (xpos),a
 
 call getrand
 and 1111b
 ld (ypos),a

 call isSpaceValid
 jr nc,TelePORTstartover

 ld hl,xpos
 inc (hl)

 call isSpaceValid
 jr nc,TelePORTstartover

 ld hl,xpos
 dec (hl)
 jp main



endGame:
 ; GAME OVER
 B_CALL grbufclr
 call loadRogueTitle

 B_CALL grbufcpy

 ld hl,0305h
 ld (currow),hl
 ld hl,game_text4
 call putsApp

 B_CALL getkey
 jp quit
